//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#pragma hdrstop

DWORD dwPluginID;

typedef VOID __stdcall (*typeCommFortProcess)(DWORD dwPluginID, DWORD dID, BYTE * bOutBuffer, DWORD dwOutBufferSize);
typedef DWORD __stdcall (*typeCommFortGetData)(DWORD dwPluginID, DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize);

typeCommFortProcess CommFortProcess;
typeCommFortGetData CommFortGetData;

extern "C" __declspec(dllexport) BOOL PluginStart(DWORD dwThisPluginID, typeCommFortProcess, typeCommFortGetData);
extern "C" __declspec(dllexport) VOID PluginStop();

extern "C" __declspec(dllexport) VOID PluginProcess(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize);
extern "C" __declspec(dllexport) DWORD PluginGetData(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize);
extern "C" __declspec(dllexport) BOOL PluginPremoderation(DWORD dwID, wchar_t * wText, DWORD *dwTextLength);

extern "C" __declspec(dllexport) VOID PluginShowOptions();
extern "C" __declspec(dllexport) VOID PluginShowAbout();

#pragma argsused
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{

	return 1;
}
//---------------------------------------------------------------------------
int fReadInteger(BYTE * bInBuffer, int * iOffset) //       
{
	int iLength;
	memcpy(&iLength, bInBuffer + (*iOffset),4);
	(*iOffset)+=4;
	return iLength;
}
//---------------------------------------------------------------------------
UnicodeString fReadText(BYTE * bInBuffer, int * iOffset) //       
{
	int iLength;
	memcpy(&iLength, bInBuffer + (*iOffset),4);
	(*iOffset)+=4;
	UnicodeString uRet;
	uRet.SetLength(iLength);
	memcpy(uRet.c_str(), bInBuffer + (*iOffset),iLength*2);
	(*iOffset)+=iLength*2;
	return uRet;
}
//---------------------------------------------------------------------------
void fWriteInteger(BYTE * bOutBuffer, int * iOffset, int iValue) //       
{
	memcpy(bOutBuffer + (*iOffset),&iValue, 4);
	(*iOffset)+=4;
}
//---------------------------------------------------------------------------
void fWriteText(BYTE * bOutBuffer, int * iOffset, UnicodeString uValue) //       
{
	int iLength = uValue.Length();

	memcpy(bOutBuffer + (*iOffset),&iLength,4);
	(*iOffset)+=4;

	memcpy(bOutBuffer + (*iOffset),uValue.c_str(),iLength*2);
	(*iOffset)+=iLength*2;
}
//---------------------------------------------------------------------------
BOOL PluginStart(DWORD dwThisPluginID, typeCommFortProcess func1, typeCommFortGetData func2)
{
	dwPluginID = dwThisPluginID;
	//     
	//   ,  
	//      

	CommFortProcess = func1;
        //   ,
	//      

	CommFortGetData = func2;
        //   ,
	//         



	//     (  ):
	AnsiString aData;
	int iSize = (*CommFortGetData)(dwPluginID, 2000, NULL, NULL, NULL, NULL); //  
	aData.SetLength(iSize);
	(*CommFortGetData)(dwPluginID, 2000,aData.c_str(),iSize, NULL, NULL);// 

	int iProgramType;
	memcpy(&iProgramType,aData.c_str(),4);// 

	if(iProgramType==0)
	ShowMessage(L"     CommFort");
	else if(iProgramType==1)
	ShowMessage(L"     CommFort");




	// :
	//TRUE -   
	//FALSE -  

	return TRUE;
}
//---------------------------------------------------------------------------
VOID PluginStop()
{
	//      
}
//---------------------------------------------------------------------------
VOID PluginProcess(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize)
{
	//  
	//:
	//dwID -  
	//bInBuffer -   
	//dwInBufferSize -    


}
//---------------------------------------------------------------------------
DWORD PluginGetData(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize)
{
        //   

	int iReadOffset = 0; //       
	int iWriteOffset = 0;

	//  dwOutBufferSize       ,   

	if(dwID==2800) // 
	{
		if(dwOutBufferSize==0)
		return 4; //   ,    

		fWriteInteger(bOutBuffer,&iWriteOffset,0);  //    ,    

		return 4;//    
	}
	else if(dwID==2810) //  (  )
	{
		UnicodeString uName = L"NULL:  ";// 
		int iSize = uName.Length()*2+4;

		if(dwOutBufferSize==0)
		return iSize; //   ,    

		fWriteText(bOutBuffer, &iWriteOffset, uName);

		return iSize;//    
	}


	return 0;//  -   
}
//---------------------------------------------------------------------------
BOOL PluginPremoderation(DWORD dwID, wchar_t * wText, DWORD *dwTextLength)
{
	// 
        //     ,      ,    

	//!    40000 .       .

	if(dwID==1010)//
	{
		UnicodeString uCheck = L"   ";

		if(wcscmp(wText,uCheck.c_str())==0)
		{
			UnicodeString uRet = L"   : ";
			memcpy(wText,uRet.c_str(),uRet.Length()*2);

			(*dwTextLength) = uRet.Length();//  

			return TRUE;//TRUE     
		}
	}

	return FALSE;//  FALSE       
}
//---------------------------------------------------------------------------
VOID PluginShowOptions()
{
	//      ""   
	//       "",    

	ShowMessage(L"Options dialog");
}
//---------------------------------------------------------------------------
VOID PluginShowAbout()
{
	//      " "   
	//       "",    

	ShowMessage(L"Test plugin for CommFort 5\n\nCreated by CommFort software Ltd.");
}
//---------------------------------------------------------------------------

