//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#pragma hdrstop

DWORD dwPluginID;

typedef VOID __stdcall (*typeCommFortProcess)(DWORD dwPluginID, DWORD dID, BYTE * bOutBuffer, DWORD dwOutBufferSize);
typedef DWORD __stdcall (*typeCommFortGetData)(DWORD dwPluginID, DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize);

typeCommFortProcess CommFortProcess;
typeCommFortGetData CommFortGetData;

extern "C" __declspec(dllexport) BOOL PluginStart(DWORD dwThisPluginID, typeCommFortProcess, typeCommFortGetData);
extern "C" __declspec(dllexport) VOID PluginStop();

extern "C" __declspec(dllexport) VOID PluginProcess(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize);
extern "C" __declspec(dllexport) DWORD PluginGetData(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize);
extern "C" __declspec(dllexport) BOOL PluginPremoderation(DWORD dwID, wchar_t * wText, DWORD *dwTextLength);

extern "C" __declspec(dllexport) VOID PluginShowOptions();
extern "C" __declspec(dllexport) VOID PluginShowAbout();

#pragma argsused
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{

	return 1;
}
//---------------------------------------------------------------------------
int fReadInteger(BYTE * bInBuffer, int * iOffset) //       
{
	int iLength;
	memcpy(&iLength, bInBuffer + (*iOffset),4);
	(*iOffset)+=4;
	return iLength;
}
//---------------------------------------------------------------------------
UnicodeString fReadText(BYTE * bInBuffer, int * iOffset) //       
{
	int iLength;
	memcpy(&iLength, bInBuffer + (*iOffset),4);
	(*iOffset)+=4;
	UnicodeString uRet;
	uRet.SetLength(iLength);
	memcpy(uRet.c_str(), bInBuffer + (*iOffset),iLength*2);
	(*iOffset)+=iLength*2;
	return uRet;
}
//---------------------------------------------------------------------------
void fWriteInteger(BYTE * bOutBuffer, int * iOffset, int iValue) //       
{
	memcpy(bOutBuffer + (*iOffset), &iValue, 4);
	(*iOffset)+=4;
}
//---------------------------------------------------------------------------
void fWriteText(BYTE * bOutBuffer, int * iOffset, UnicodeString uValue) //       
{
	int iLength = uValue.Length();

	memcpy(bOutBuffer + (*iOffset),&iLength,4);
	(*iOffset)+=4;

	memcpy(bOutBuffer + (*iOffset),uValue.c_str(),iLength*2);
	(*iOffset)+=iLength*2;
}
//---------------------------------------------------------------------------
AnsiString fTextToAnsiString(UnicodeString uText) //      
{
	//    ,
	//    ,
	//        

	int iLength = uText.Length();

	AnsiString aReturn;

	aReturn.SetLength(4+iLength*2);

	memcpy(aReturn.c_str(),&iLength,4);
	memcpy(aReturn.c_str()+4,uText.c_str(),iLength*2);

	return aReturn;
}
//---------------------------------------------------------------------------
AnsiString fIntegerToAnsiString(int iValue) //      
{
	//    ,
	//    ,
	//        

	AnsiString aReturn;
	aReturn.SetLength(4);
	memcpy(aReturn.c_str(),&iValue,4);

	return aReturn;
}
//---------------------------------------------------------------------------
BOOL PluginStart(DWORD dwThisPluginID, typeCommFortProcess func1, typeCommFortGetData func2)
{
	dwPluginID = dwThisPluginID;
	//     
	//   ,  
	//         

	CommFortProcess = func1;
        //   ,
	//      

	CommFortGetData = func2;
        //   ,
	//         


	//  

	AnsiString aDataToSend = fTextToAnsiString(L"Repeater")+  //
		fTextToAnsiString(L"192.168.0.0")+ //IP-
		fIntegerToAnsiString(0)+  //   
		fTextToAnsiString(L"bkjxzbibe47bed8w7")+   //
		fIntegerToAnsiString(0); // 

	(*CommFortProcess)(dwPluginID,1001,aDataToSend.c_str(),aDataToSend.Length());

	// :
	//TRUE -   
	//FALSE -  
	return TRUE;
}
//---------------------------------------------------------------------------
VOID PluginStop()
{
	//      
}
//---------------------------------------------------------------------------
VOID PluginProcess(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize)
{
	//  
	//:
	//dwID -  
	//bInBuffer -   
	//dwInBufferSize -    

	int iReadOffset = 0;

	if(dwID==1070) //   
	{
		//   
		UnicodeString uVirtualUserLogin = fReadText(bInBuffer, &iReadOffset);
		UnicodeString uSenderLogin = fReadText(bInBuffer, &iReadOffset);
		UnicodeString uSenderIP = fReadText(bInBuffer, &iReadOffset);
		int iSenderIcon = fReadInteger(bInBuffer, &iReadOffset);
		UnicodeString uChannel = fReadText(bInBuffer, &iReadOffset);
		int iMessageMode = fReadInteger(bInBuffer, &iReadOffset);
                UnicodeString uText = fReadText(bInBuffer, &iReadOffset);

                //  
		AnsiString aDataToSend = fTextToAnsiString(L"Repeater")+  //  
		fIntegerToAnsiString(0)+  // 
		fTextToAnsiString(uSenderLogin)+
		fTextToAnsiString(uText); //

		(*CommFortProcess)(dwPluginID,1022,aDataToSend.c_str(),aDataToSend.Length());
	}

}
//---------------------------------------------------------------------------
DWORD PluginGetData(DWORD dwID, BYTE * bInBuffer, DWORD dwInBufferSize, BYTE * bOutBuffer, DWORD dwOutBufferSize)
{
        //   

	int iReadOffset = 0; //       
	int iWriteOffset = 0;

	//  dwOutBufferSize       ,   

	if(dwID==2800) // 
	{
		if(dwOutBufferSize==0)
		return 4; //   ,    

		fWriteInteger(bOutBuffer,&iWriteOffset,1);  //    

		return 4;//    
	}
	else if(dwID==2810) //  (  )
	{
		UnicodeString uName = L"Repeater ( )";// 
		int iSize = uName.Length()*2+4;

		if(dwOutBufferSize==0)
		return iSize; //   ,    

		fWriteText(bOutBuffer, &iWriteOffset, uName);

		return iSize;//    
	}


	return 0;//  -   
}
//---------------------------------------------------------------------------
VOID PluginShowAbout()
{
	//      " "   

	ShowMessage(L"        .\n\nCreated by CommFort software Ltd.");
}
//---------------------------------------------------------------------------

